; File:         TestCycles8_10D.asm
; Written by    RuiLoureiro             @masmforum
;-----------------------------------
include \masm32\include\masm32rt.inc
.686
; 
;                            Console Assemble & Link
; 

                            include  PowerTable.inc
                            include  Convert8DR.inc
                            include  Convert8DRD.inc
                            include  Convert8DS.inc
                            include  Convert8DSD.inc
                            
                            include  Timing.inc

$DECIMALPLACES_REAL8  equ 14
; 
.data
;-------- for timing -------------
_Real8_Time  dq -12345634.5678234

;-----------------------------------------
            dd 100
            dd 0
_RclBuf     db 101 dup (0) 
;-----------------------------------------

_String8DR1  db "  cycles, ConvertFloat8DR  - 15 digits",0
_String8DR2  db "  cycles, ConvertReal8DR   - 15 digits",0
_String8DRD1 db "  cycles, ConvertFloat8DRD - 15 digits",0
_String8DRD2 db "  cycles, ConvertReal8DRD  - 15 digits",0

_String8DS1  db "  cycles, ConvertFloat8DS  - 15 digits",0
_String8DS2  db "  cycles, ConvertReal8DS   - 15 digits",0
_String8DSD1 db "  cycles, ConvertFloat8DSD - 15 digits",0
_String8DSD2 db "  cycles, ConvertReal8DSD  - 15 digits",0

             dd 8
_TblString0  dd offset _String8DR1
             dd offset _String8DR2
             dd offset _String8DRD1
             dd offset _String8DRD2
             ;
             dd offset _String8DS1
             dd offset _String8DS2
             dd offset _String8DSD1
             dd offset _String8DSD2             
;-----------------------------------
.data?
_Real8_R    dq ?
; 
.code
;=============================================================
start:
            finit
            fldpi
            fstp    qword ptr _Real8_R

            invoke  ConvertFloat8DR, addr _Real8_R, addr _RclBuf
            print   addr _RclBuf, 13, 10 
            invoke  ConvertReal8DR, addr _Real8_R, 0
            print   edx, 13, 10 

            invoke  ConvertFloat8DRD, addr _Real8_R, addr _RclBuf, $DECIMALPLACES_REAL8
            print   addr _RclBuf, 13, 10 
            invoke  ConvertReal8DRD, addr _Real8_R, 0, $DECIMALPLACES_REAL8
            print   edx, 13, 10

            invoke  ConvertFloat8DS, addr _Real8_R, addr _RclBuf
            print   addr _RclBuf, 13, 10 
            invoke  ConvertReal8DS, addr _Real8_R, 0
            print   edx, 13, 10 

            invoke  ConvertFloat8DSD, addr _Real8_R, addr _RclBuf, $DECIMALPLACES_REAL8
            print   addr _RclBuf, 13, 10 
            invoke  ConvertReal8DSD, addr _Real8_R, 0, $DECIMALPLACES_REAL8
            print   edx, 13, 10
 
            inkey " -------------- Pi value ---------------- "            
;--------------------------------------------------------------------------        
            START_COUNTER_CYCLE_HIGH_PRIORITY_CLASS
            invoke  ConvertFloat8DR, addr _Real8_Time, addr _RclBuf
            SAVE_COUNTER_CYCLE < cycles, ConvertFloat8DR, _Real8_Time >

            START_COUNTER_CYCLE_HIGH_PRIORITY_CLASS
            invoke  ConvertReal8DR, addr _Real8_Time, 0
            SAVE_COUNTER_CYCLE < cycles, ConvertReal8DR, _Real8_Time >

            START_COUNTER_CYCLE_HIGH_PRIORITY_CLASS
            invoke  ConvertFloat8DRD, addr _Real8_Time, addr _RclBuf, $DECIMALPLACES_REAL8
            SAVE_COUNTER_CYCLE < cycles, ConvertFloat8DRD, _Real8_Time >

            START_COUNTER_CYCLE_HIGH_PRIORITY_CLASS
            invoke  ConvertReal8DRD, addr _Real8_Time, 0, $DECIMALPLACES_REAL8
            SAVE_COUNTER_CYCLE < cycles, ConvertReal8DRD, _Real8_Time >

            START_COUNTER_CYCLE_HIGH_PRIORITY_CLASS
            invoke  ConvertFloat8DS, addr _Real8_Time, addr _RclBuf
            SAVE_COUNTER_CYCLE < cycles, ConvertFloat8DS, _Real8_Time >

            START_COUNTER_CYCLE_HIGH_PRIORITY_CLASS
            invoke  ConvertReal8DS, addr _Real8_Time, 0
            SAVE_COUNTER_CYCLE < cycles, ConvertReal8DS, _Real8_Time >

            START_COUNTER_CYCLE_HIGH_PRIORITY_CLASS
            invoke  ConvertFloat8DSD, addr _Real8_Time, addr _RclBuf, $DECIMALPLACES_REAL8
            SAVE_COUNTER_CYCLE < cycles, ConvertFloat8DSD, _Real8_Time >

            START_COUNTER_CYCLE_HIGH_PRIORITY_CLASS
            invoke  ConvertReal8DSD, addr _Real8_Time, 0, $DECIMALPLACES_REAL8
            SAVE_COUNTER_CYCLE < cycles, ConvertReal8DSD, _Real8_Time >

;.........................................................................
            inkey " *** Press any key to get the time table *** "
            call    SortCycles
;------------------------------------------------------------------------------
            inkey " ********** END ********** "            
            exit
;***********************************************************************************************
end start

